"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// Angular Library-Importe
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var FlugService_1 = require('../Services/FlugService');
var Flugliste = (function () {
    function Flugliste(flugService, router) {
        this.flugService = flugService;
        this.router = router;
        console.log("Flugliste.Konstruktor!!!");
    }
    Flugliste.prototype.ngOnInit = function () {
        this.DatenLaden();
    };
    // andere Form:
    // ngOnInit() {
    //    this.flugService.getAll(daten => { // Callback
    //    this.flugSet = this.flugService.flugSet;
    //    this.status = this.flugSet.length + " Flüge geladen.";
    //   });
    //  }
    Flugliste.prototype.DatenLaden = function () {
        var _this = this;
        this.flugService.getAll(function (daten) {
            _this.flugSet = _this.flugService.flugSet;
            _this.status = _this.flugSet.length + " Flüge geladen.";
            console.log("Callback empfangen!");
        });
    };
    Flugliste.prototype.DatenLaden2 = function () {
        this.flugSet = this.flugService.flugSet;
        this.status = this.flugSet.length + " Flüge geladen.";
    };
    // löschen hier in dieser Komponente
    Flugliste.prototype.Loeschen = function (flug) {
        this.flugService.delete(flug); // Dienst aufrufen
        // this.flugSet = this.flugService.flugSet; // Datenbindung aktualisieren
        this.status = "Flug " + flug.FlugNr + " gel\u00F6scht!";
        // console.log("delete(): " + this.flugSet.length);
    };
    // Sprung zur Edit-Ansicht
    Flugliste.prototype.Aendern = function (flug) {
        var link = ['/edit', flug.FlugNr];
        this.router.navigate(link); // Ansicht aufrufen
    };
    // Event-Handler für Nachricht von untergeordneter Komponente, wenn diese Flug gelöscht hat
    Flugliste.prototype.onFlugGeloescht = function (flug) {
        console.log("flugGeloeschtEvent");
        this.status = "Flug " + flug.FlugNr + " gel\u00F6scht!";
        this.flugSet = this.flugService.flugSet; // Datenbindung aktualisieren
    };
    Flugliste = __decorate([
        // für Event
        core_1.Component({
            selector: 'Flugliste',
            templateUrl: 'App/Flugliste/Flugliste.html',
            styleUrls: ['App/Flugliste/Flugliste.css'],
            providers: [FlugService_1.FlugService],
        }), 
        __metadata('design:paramtypes', [FlugService_1.FlugService, router_1.Router])
    ], Flugliste);
    return Flugliste;
}());
exports.Flugliste = Flugliste;
//# sourceMappingURL=Flugliste.js.map