// Spielwiese für verschiedene Beispiele zur Datenbindung
"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// Angular-Importe
var core_1 = require('@angular/core');
var router_1 = require('@angular/router');
var Rx = require('rxjs/Observable');
// Importe für eigene Klassen
var Flug_1 = require('../Modell/Flug');
var FlugService_1 = require('../Services/FlugService');
var Datengenerator_1 = require('../Services/Datengenerator'); // für Event
var Datenbindung = (function () {
    function Datenbindung(flugService, router, differs, ref) {
        var _this = this;
        this.flugService = flugService;
        this.router = router;
        this.differs = differs;
        this.ref = ref;
        this.differ = differs.find({}).create(null);
        // Trigger für Update des UI 1x pro Sekunde!
        // this.timerSync = Rx.Observable.interval(1000).startWith(0).subscribe(x => this.timerSync = x);
        // this.timerAsync = Rx.Observable.interval(1000).startWith(0);
        this.zahlen = [1, 2, 3, 4, 5];
        this.zahlenO = Rx.Observable.of(this.zahlen);
        this.fluege = new Datengenerator_1.Datengenerator().getTestData();
        this.fluegeO = Rx.Observable.of(this.fluege);
        this.flugService.getAll(function (x) { return _this.fluege2 = x; });
        this.fluege2O = this.flugService.getAllAsOversable();
    }
    Datenbindung.prototype.ngOnInit = function () {
        // this.DatenLaden();
        this.a = new Array();
        this.f1 = new Flug_1.Flug();
        this.f1.FlugNr = 101;
        this.f1.FreiePlaetze = 222;
        this.f1.Abflugort = "Rom";
        var f2 = new Flug_1.Flug();
        f2.FlugNr = 102;
        f2.Abflugort = "Rom";
        var f3 = new Flug_1.Flug();
        f3.FlugNr = 103;
        this.a.push(this.f1);
        this.a.push(f2);
        this.a.push(f3);
        var o1;
        var o2;
        // falsch!
        // o1 = Observable.of(a);
        // o2 = Observable.from(a);
        o1 = Rx.Observable.from(this.a); // jedes Element einzeln in Sequence
        o2 = Rx.Observable.of(this.a); // Array als ein Element in Sequence
        o1.count().subscribe(function (x) { return console.log("Anz o1:" + x); }); // 3 --> drei Elemente im Observable
        o2.count().subscribe(function (x) { return console.log("Anz o2:" + x); }); // 1 --> ein Array (mit drei Elementen) in Observable
        var o3 = o2.flatMap(function (x) { return x; });
        o3.count().subscribe(function (x) { return console.log("Anz o3:" + x); }); // 1 --> zwei Elemente im Observable
        o3.subscribe(function (x) { return console.log("o3", x); }); // 1 --> zwei Elemente im 
        var o4 = o2.flatMap(function (x) { return x; }).filter(function (x) { return x.FlugNr < 102; }).toArray();
        o4.count().subscribe(function (x) { return console.log("Anz o4:" + x); });
        var o5 = Rx.Observable.of(this.a, this.a, this.a, this.a); // Observable mit 4 Arrays
        o5.count().subscribe(function (x) { return console.log("Anz o5:" + x); });
        o5.subscribe(function (x) { return console.log("o5", x); }); // 1 --> zwei Elemente im 
        // UI-Bindung
        // tatsächlich erwartet Angular 2 ein Observable, dass ein Array von Flug verpackt :-(
        // this.flugSet = o2;
        // das geht nicht "NgFor only supports binding to Iterables such as Arrays."
        // this.flugSet = o4;
        // this.update0();
        this.fluegeO = o5;
    };
    Datenbindung.prototype.update0 = function () {
        console.log("Update0 Daten aus Dummy");
        this.flug = this.f1;
        this.fluege = this.a;
        this.fluegeO = Rx.Observable.of(this.a, this.a);
    };
    Datenbindung.prototype.update1 = function () {
        console.log("Update1 Quellobjekt");
        this.f1.FreiePlaetze--;
        this.a[0].FreiePlaetze--;
        ;
        this.a.pop();
    };
    Datenbindung.prototype.update2 = function () {
        console.log("Update2 gebundenes Objekt!");
        this.flug.FreiePlaetze--;
        this.fluege[0].FreiePlaetze--;
        this.fluege.pop();
    };
    Datenbindung.prototype.update3 = function () {
        var _this = this;
        console.log("Update3 aus Datengenerator!");
        this.flugService.getAll(function (x) { return _this.fluege = x; });
        this.fluege = this.flugService.flugSet;
        this.fluegeO = this.flugService.getAllAsOversable();
        this.flug = this.flugService.flugSet[0];
    };
    Datenbindung.prototype.update4 = function () {
        console.log("Update4 Quelldaten");
        this.flugService.flugSet[0].FreiePlaetze--;
        this.flugService.deleteById(103);
    };
    // nur zur Diagnose!
    Datenbindung.prototype.ngOnChanges = function (changes) {
        console.log('ngDoCheck: Change detected:', changes);
    };
    // nur zur Diagnose!
    Datenbindung.prototype.ngDoCheck = function () {
        var changes = this.differ.diff(this.flugSet);
        if (changes) {
            console.log('ngDoCheck: changes detected', changes);
        }
        else {
            console.log('ngDoCheck: nothing changed');
        }
    };
    Datenbindung.prototype.DatenLaden = function () {
        var _this = this;
        this.flugService.getAll(function (daten) {
            _this.flugSet = _this.flugService.flugSet;
            _this.status = _this.flugSet.length + " Flüge geladen.";
            // oder wenn Observable hochgereicht wird:
            // this.flugService.getAll().subscribe(x => {  this.flugSet =x; console.log("subscribe...", x);} );
        });
    };
    Datenbindung.prototype.Loeschen = function (flug) {
        this.flugService.delete(flug);
        this.flugSet = this.flugService.flugSet;
        this.status = "Flug " + flug.FlugNr + " gel\u00F6scht!";
        console.log("delete(): " + this.flugSet.length);
    };
    Datenbindung.prototype.onDatenGeaendertEvent = function (flug) {
        console.log("EVENT: Flug geändert", flug);
        this.flugSet = this.flugService.flugSet;
    };
    Datenbindung.prototype.Aendern = function (flug) {
        var link = ['/edit', flug.FlugNr];
        this.router.navigate(link);
    };
    Datenbindung = __decorate([
        // für Event
        core_1.Component({
            selector: 'Flugliste',
            templateUrl: 'App/_misc/Datenbindung.html',
            changeDetection: core_1.ChangeDetectionStrategy.Default,
            providers: [FlugService_1.FlugService] // Lokale Registrierung eines Dienstes für Dependency Injection
        }), 
        __metadata('design:paramtypes', [FlugService_1.FlugService, router_1.Router, core_1.KeyValueDiffers, core_1.ChangeDetectorRef])
    ], Datenbindung);
    return Datenbindung;
}());
exports.Datenbindung = Datenbindung;
//# sourceMappingURL=Datenbindung.js.map